/*****************************************************************************
**
** program_ugnx3_set_ipac_attributes.cpp
**
** Description:
**     Contains Unigraphics entry points for the application.
**
*****************************************************************************/

/* Include files */
#if ! defined ( __hp9000s800 ) && ! defined ( __sgi ) && ! defined ( __sun )
#   include <strstream>
#   include <iostream>
    using std::ostrstream;
    using std::endl;    
    using std::ends;
    using std::cerr;
#else
#   include <strstream.h>
#   include <iostream.h>
#endif



#include <stdlib.h>
#include <stdio.h>
#include <time.h>
#include <math.h>


#include <uf.h>
#include <uf_obj.h>
#include <uf_ui.h>
#include <uf_disp.h>
#include <uf_assem.h>
#include <uf_part.h>
#include <uf_attr.h>
#include <uf_vec.h>




FILE*		prterr;
int			errorCode;

char**		rivet_attr;	
int			rivet_cnt;
int			rivet_ans;

char**		pr_code_attr;
int			pr_code_cnt;
int			pr_code_ans;

char**		ad_code_attr;
int			ad_code_cnt;
int			ad_code_ans;

char**		fast_code_attr;
int			fast_code_cnt;
int			fast_code_ans;

char**		grip_lng_attr;
int			grip_lng_cnt;
int			grip_lng_ans;



#define	PRTERR(line)if(errorCode)\
	{PrintErrorMessage(errorCode,line);errorCode=0;goto term;}

extern int create_dialog ( int *response );

static void PrintErrorMessage(int errorCode, int line)
{
	if(errorCode)
	{
		char	message[133];

		UF_get_fail_message(errorCode,message);
		UF_UI_set_status(message);
		fprintf(prterr,"errorCode=%d	message=%s		line=%d	\n",
			errorCode,message,line);
	}
}


void do_it(void)
{

	char*	rivet_tbl[]={"work","metal","techno"};
	char*	pr_code_tbl[]={"A","B","C", "D","E","F", "G","H","I","J",		//10
		"K","L","M", "N","O","Q", "R","S","T","U", "V","W","X","Y","Z"};	//15=25
	char*	ad_code_tbl[]={"A","B"};
	char*	fast_code_tbl[]=	{	"3403979D4","3403979D5","3403979D6",					//3
								"3404579D4","3404579D5","3404579D6",						//3
								"3404680D4","3404680D5",									//2
								"3404480D4","3404480D5","3404480D6","3404480D7",			//4
								"3003779D5","3003779D6","3003779D8",						//3
								"3004182D5","3004182D6","3004182D8"};						//3=18

	char*	grip_lng_tbl[]=		{	"080","095","110",		"125","140","155",	"170","185",		//8	
									"200","215","230",	"245","250","260",	"270","275",		//8
									"280","290","300",	"310","320","330",	"340","350",		//8
									"360","370","380",	"390","400","410",	"420"};			//7=31

	
	rivet_cnt=3;
	pr_code_cnt=25;
	ad_code_cnt=2;
	fast_code_cnt=18;
	grip_lng_cnt=31;
	
	rivet_attr=rivet_tbl;
	pr_code_attr=pr_code_tbl;
	ad_code_attr=ad_code_tbl;
	fast_code_attr=fast_code_tbl;
	grip_lng_attr=grip_lng_tbl;






	int	resp;
	errorCode=create_dialog(&resp);


goto term;

term:
	fflush(prterr);
	return;
}





/*****************************************************************************
**  Activation Methods
*****************************************************************************/
/*  Explicit Activation
**      This entry point is used to activate the application explicitly, as in
**      "File->Execute UG/Open->User Function..." */
extern DllExport void ufusr( char *parm, int *returnCode, int rlen )
{









	//   
	struct	tm*		newtime;
	time_t			aclock,
					start_time,
					finish_time;
	double			work_time;
	int				min,sec;


	time(&start_time);

	//  prterr.txt    D:
	//
	if((prterr=fopen("D:\\prterr.txt","w"))!=NULL)
	{
		uc1601("  <prterr.txt>    D:\\",1);
		goto label_clock;
	}

	//  prterr.txt   TEMP
	//
	if((prterr=fopen("C:\\TEMP\\prterr.txt","w"))!=NULL)
	{
		uc1601("  <prterr.txt>    D:\\TEMP\\",1);
		goto label_clock;
	}

	//  <prterr.txt>      
	//
	uc1601("     <prterr.txt>",1);
	return;

label_clock:
	time(&aclock);
	newtime=localtime(&aclock);
	fprintf(prterr,"<set_IPAC_attributes> STARTED		line=%d\n\n",__LINE__);
	fprintf(prterr,"    %s\n\n",asctime(newtime));
	fflush(prterr);

	errorCode=UF_initialize();PRTERR(__LINE__);

	do_it();

	errorCode=UF_terminate();PRTERR(__LINE__);

term:
	time(&finish_time);
	work_time=difftime(finish_time,start_time);
	min=(int)work_time/60;
	sec=(int)(work_time-min*60);
	fprintf(prterr,"<set_IPAC_attributes> FINISHED		line=%d\n\n",__LINE__);
	fprintf(prterr,"work_time is	%u min	%u sec\n",min,sec);
	fflush(prterr);
	fclose(prterr);
	if(UF_is_initialized())
		UF_terminate();
	return;










}

/*****************************************************************************
**  Utilities
*****************************************************************************/

/* Unload Handler
**     This function specifies when to unload your application from Unigraphics.
**     If your application registers a callback (from a MenuScript item or a
**     User Defined Object for example), this function MUST return
**     "UF_UNLOAD_UG_TERMINATE". */
extern int ufusr_ask_unload( void )
{
    return( UF_UNLOAD_IMMEDIATELY );
}
